/*
 * Copyright (C) 2018 Andrey V. Skvortsov <starling13@mail.ru>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <VGA.h>

#include "vgaterminal.hpp"

// USART to host
#define HOST_PORT Serial3
// Baudrate
#define HOST_BR 115200
// Resolution
static const uint16_t width = 640;
static const uint16_t height = 480;

static Videoterminal videoTerm;

void
setup()
{
	HOST_PORT.begin(115200);
	VGA.begin(width, height);
	while (!HOST_PORT);
}

void
loop()
{
	static uint8_t buf[255];

	int bytes = HOST_PORT.available();
	if (bytes > 0) {
		const uint8_t c = HOST_PORT.readBytes(buf, min(bytes, 255));
		const uint8_t *p = buf;
		while ((bytes--) > 0)
			videoTerm.write(*(p++));
	}
}
