/*
 * ArduinoExt is a set of utility libraries for Arduino
 * Copyright (C) 2016, 2017 Andrey V. Skvortsov <starling13@mail.ru>
 *
 * This program is free software: is free software: you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.

 * ArduinoExt library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with Posixcpp library. If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "vgaterminal.hpp"

#include <VGA.h>

void
Videoterminal::clear()
{
	VGA.clear(0);
}

uint8_t
Videoterminal::getCursorX()
{
	return VGA.tx;
}

void
Videoterminal::setCursor(uint8_t x, uint8_t y)
{
	VGA.moveCursor(x, y);
}

void
Videoterminal::setCursorX(uint8_t x)
{
	VGA.moveCursor(x, VGA.ty);
}

void
Videoterminal::writeChar(uint8_t c)
{
	VGA.write(c);
}

void
Videoterminal::addAttribute(VT100::TextAttr attr)
{
	switch (attr) {
	case VT100::BRIGHT:
		m_bright = true; break;
	}
}

void
Videoterminal::resetAttributes()
{
	m_bright = false;
}
