/*
 * ArduinoExt is a set of utility libraries for Arduino
 * Copyright (C) 2016, 2017 Andrey V. Skvortsov <starling13@mail.ru>
 *
 * This program is free software: is free software: you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.

 * ArduinoExt library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with Posixcpp library. If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef VGATERMINAL_HPP
#define VGATERMINAL_HPP

#include "vt100.hpp"

class Videoterminal : public VT100::Print
{
	// VT100::Print interface
public:

	void clear() override;

protected:

	uint8_t getCursorX() override;

	void setCursor(uint8_t, uint8_t) override;

	void setCursorX(uint8_t) override;

	void writeChar(uint8_t) override;

	void addAttribute(VT100::TextAttr) override;

	void resetAttributes() override;

private:

	enum Colors : uint8_t
	{
		COLOR_WHITE = 0xFF, //0b11111111
		COLOR_LIGHT_GREY = 0xB6, //0b10110110
		COLOR_YELLOW = 0xFC, //0b11111100
		COLOR_ORANGE = 0xF0, //0b11110000
		COLOR_RED = 0xE0, //0b11100000
		COLOR_GREY = 0x92, //0b10010010
		COLOR_LIGHT_GREEN = 0x5E, //0b01011110
		COLOR_GREEN = 0x1C, //0b00011100
		COLOR_DARK_GREEN = 0x10, //0b00010000
		COLOR_CYAN = 0x1F, //0b00011111
		COLOR_BLUE = 0x03, //0b00000011
		COLOR_BLACK = 0x00, //0b00000000
		COLOR_MAGENTA = 0xE3, //0b11100011
	};

	bool m_bright;
	
	Colors m_color;
};

#endif
